// KESIReader
// Copyright 2005-2006 Kurzweil Educational Systems, Inc.
// Version 2.2. Last modified 11/6/06 MikeG
// HINT: A good sign of a syntax error in KESIReader is if the WPM indicator stays blank.

var gKESIBrowser = null;
var gKESIInStream = null;
var gKESIOutStream = null;
var gKESIStartupSocket = null;
var gKESIHighlightDoc = null;
var gKESIHighlightAltNode = null;
var gKESIHighlightAltNodeBorder = null;
var gKESIReadAltText = false;
var gKESIIsMac = false;
var gKESI3000LaunchStatus = 0;	// 1 = launching, 2 = launched
var gKESILoadWinCounter = 0;
var gKESIInit2Done = false;
var lastClickLocation = null;

// Default values for Preferences (about:config)
var gKESIPort = 1007;	// 5002 if Macintosh
var gKESIStartupPort = 5003;
var gKESISuppressDebuggingAlerts = false;
var gKESIExePath = "C:\\Program Files\\Kurzweil Educational Systems\\Kurzweil 3000\\Kurzweil 3000.exe";

var gKESIProcess = null; // #8908, 8909
var gKESIProcessInitDone = false; // #8908, 8909

var gKESIOnStateFlags = (Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT 
						| Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK 
						| Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW);
var gLogNum = 0;

function writeLog(text) {
/* 	var now = new Date();
	gLogNum += 1;
	console.log(now.toISOString() + " " + gLogNum.toString() + " " + text);
 */
 }

var KESISocketListener =
{
	onStartRequest: function(request, context)
	{
		//alert("onStartRequest, context: " + context + " request: " + request);
	},

	onStopRequest: function(request, context, status)
	{
		//alert("onStopRequest, context: " + context + " status: " + status);
		KESIHighlightReset();
		KESIClearAllHighlights();
		KESICloseConnection();

		if (gKESIBrowser)
		{
			gKESIBrowser.removeProgressListener(KESIBrowserProgressListener);
		}
	},

	onDataAvailable: function(request, context, inputStream, offset, count)
	{
		var dat = gKESIInStream.read(count);
		KESIDoCommand(dat);
	}
};


function KESIDoCommand(aCmd)
{
	var myButtonCode, myStateCode, myMenuCode;

	for (var n = 0; n < aCmd.length; ++n)
	{
		var ch = aCmd.charAt(n);

		if (ch == "h")
		{
			// highlight
			var selStart = 0;
			var selLength = 0;
			var selGroup = aCmd.charAt(++n);
			var color = "";
			var nArg = 0;
			var val = 0;

			for (; ++n < aCmd.length;)
			{
				ch = aCmd.charAt(n);

				if (ch == ";")
				{
					break;
				}
				else if (ch == ",")
				{
					if (nArg === 0) 
						selStart = val;
					if (nArg == 1)
						selLength = val;

					++nArg;
					val = 0;
				}
				else
				{
					if (nArg < 2)
					{
						val = val * 10 + (aCmd.charCodeAt(n) - 48);
					}
					else
					{
						color = color + ch;
					}
				}
			}

			KESIHighlightText(content.document, selStart, selLength, color, selGroup);
		}
		else if (ch == "u")
		{
			KESIClearHighlightGroup(gKESIHighlightDoc, aCmd.charAt(++n));
		}
		else if (ch == "r")
		{
			KESISendSelection("r");
		}
		else if (ch == "G")
		{
			var str = KESIGatherText(content.document);
			KESIHighlightReset();
			gKESIHighlightDoc = content.document;	// 6037
			KESIClearAllHighlights();			// 6037
			str = KESIToUTF8(str);
			KESISendSocketMessage("t" + str.length + "," + str);
		}
		else if (ch == "A")
		{
			gKESIReadAltText = true;
		}
		else if (ch == "a")
		{
			gKESIReadAltText = false;
		}
		else if (ch == "I")
		{
			KESIInit2();
			if (gKESI3000LaunchStatus > 1) {
				window.status = "";
			}
		}
		else if (ch == "d")
		{
			var url = "";

			for (; ++n < aCmd.length;)
			{
				ch = aCmd.charAt(n);

				if (ch == ";")
					break;

				url = url + ch;
			}

			//alert(url);

			window.open(url, "KESIDictionary",
"left=100,top=100,height=400,width=600,location=no,toolbar=yes,status=no,menubar=no,scrollbars=yes,resizable=yes");
		}
		else if (ch == "W")
		{
			var wpm = "";

			for (; ++n < aCmd.length;)
			{
				ch = aCmd.charAt(n);

				if (ch == ";")
					break;

				wpm = wpm + ch;
			}
			var myBox = document.getElementById("KESI-WPMBox");
			if (myBox != null) myBox.value = wpm;
		}
		else if (ch == "x")
		{
			myButtonCode = aCmd.charAt(n+1);
			myStateCode = aCmd.charAt(n+2);
			n = n + 2;

			var myButton;

			switch(myButtonCode)
			{
				case "1":
				myButton = document.getElementById("KESI-Prev");
				break;

				case "2":
				myButton = document.getElementById("KESI-Play");
				break;

				case "3":
				myButton = document.getElementById("KESI-Next");
				break;

				case "4":
				myButton = document.getElementById("KESI-Dict");
				break;

				case "5":
				myButton = document.getElementById("KESI-Syl");
				break;

				case "7":
				myButton = document.getElementById("KESI-Mag");
				break;

				default:
				myButton = null;
				break;
			}

			if (myButton != null) {
				switch(myStateCode)
				{
					case "0":
					myButton.checked = false;
					break;

					case "1":
					myButton.checked = true;
					break;

					default:
					break;
				}
			}
		}
		else if (ch == "z")
		{
			myMenuCode = aCmd.charAt(n+1);
			myStateCode = aCmd.charAt(n+2);
			var myMenu;
			n = n + 2;

			if(myMenuCode == "1")
			{
				myMenu = document.getElementById("KESI-ReadModeList");

				if (myMenu != null) {
					switch(myStateCode)
					{
						case "1":
						myMenu.selectedIndex = 0;
						break;

						case "2":
						myMenu.selectedIndex = 1;
						break;

						case "3":
						myMenu.selectedIndex = 2;
						break;

						default:
						break;
					}
				}
			}
			else if(myMenuCode == "2")
			{
				myMenu = document.getElementById("KESI-ReadByList");

				if (myMenu != null) {
					switch(myStateCode)
					{
						case "1":	//word
						myMenu.selectedIndex = 0;
						break;

						case "2":	//phrase
						if (window.navigator.language == "en") {     
							myMenu.selectedIndex = 1;
						}
						break;

						case "3":	//line
						//myMenu.selectedIndex = 2;
						break;

						case "4":	//sentence
						myMenu.selectedIndex = 2;
						break;

						case "5":	//paragraph
						myMenu.selectedIndex = 3;
						break;

						case "6":	//heading
						//myMenu.selectedIndex = 5;
						break;

						case "7":	//highlight
						//myMenu.selectedIndex = 6;
						break;

						default:
						break;
					}
				}
			}
		}
		else if (ch == "X")
		{
			gKESI3000LaunchStatus = 0;
		}
		else if (ch == "S")
		{
			var msg = "";
			for (; ++n < aCmd.length;) {
				ch = aCmd.charAt(n);
				if (ch == ";")
					break;
				msg = msg + ch;
			}
			//window.status = msg;	//does not work
			alert(msg);
		}
		else if (ch == "E")
		{
			var exe;
			exe = "";
			for (; ++n < aCmd.length;) {
				ch = aCmd.charAt(n);
				if (ch == ";")
					break;
				exe = exe + ch;
			}
			if (exe != gKESIExePath) {
				gKESIExePath = exe;
				try {
					var prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
					var Branch = prefObj.getBranch("kesireader.");
					Branch.setCharPref("exePath", gKESIExePath);
				} catch (ex) {
				}
			}
		} else {
			if ("A" <= ch && ch <= "Z") {	// future ;-terminated commands should be UPPERCASE
				for (; ++n < aCmd.length;) {
					if (aCmd.charAt(n) == ";")
						break;
				}
			}
		}
	}
}


// This succeeds even if K3000 is not there. (but KESISendSocketMessage will fail
// eventually, but not necessarily the first time)

function KESIInitSocket()
{
	if (gKESIInStream) {
		return;
	}

	var host = "127.0.0.1";

	try {
		var transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"]
					.getService(Components.interfaces.nsISocketTransportService);

		var transport = transportService.createTransport(null, 0, host, gKESIPort, null);
		gKESIOutStream = transport.openOutputStream(0, 0, 0);	// first arg 2 = OPEN_UNBUFFERED, 1 = OPEN_BLOCKING
	} catch (ex) {
		KESIAlert("KESIInitSocket OutStream: " + ex);
	}

	try {
		var stream = transport.openInputStream(0, 0, 0);

		gKESIInStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
					.createInstance(Components.interfaces.nsIScriptableInputStream);

		gKESIInStream.init(stream);

		var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"]
					.createInstance(Components.interfaces.nsIInputStreamPump);

		pump.init(stream, -1, -1, 0, 0, false);
		pump.asyncRead(KESISocketListener, null);
	} catch (ex) {
		KESIAlert("KESIInitSocket InStream: " + ex);
	}
}


function KESISendSocketMessage(aData)
{
	try {
		if (!gKESIOutStream)
			return false;

		gKESIOutStream.write(aData, aData.length);
	} catch (ex) {
		//alert("KESISendSocketMessage (" + aData + ") error: " + ex);
		return false;
	}

	return true;
}

function KESIStartPage() {
	KESIHighlightReset();
	KESIClearAllHighlights();
	KESISendSocketMessage("L");
}

function KESIStopPage() {
	KESISendSocketMessage("p");
	KESISendSelection("c");
}

// these messages do not happen when user's starting pages are loading
// http://kb.mozillazine.org/Progress_listeners
// now at https://developer.mozilla.org/en-US/Add-ons/Code_snippets/Progress_Listeners (March 29, 2016)
// see also: https://developer.mozilla.org/en-US/docs/Mozilla/Tech/XPCOM/Reference/Interface/nsIWebProgressListener

var KESIBrowserProgressListener =
{
	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
	{
		// Components.interfaces.nsIWebProgressListener.
        // STATE_STOP = 0x0010   STATE_START = 0x0001   STATE_IS_DOCUMENT = 0x00020000
        // we do start/stop process if any of these upper flag bits are set: (STATE_IS_DOCUMENT | STATE_IS_NETWORK |
        // STATE_IS_WINDOW) KESISendSocketMessage("dStateChange " + aStateFlags + ";");
/* 		var stateText = "onStateChange: ";
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_RESTORING) {
			stateText += " STATE_RESTORING";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
			stateText += " STATE_IS_DOCUMENT";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK) {
			stateText += " STATE_IS_NETWORK";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW) {
			stateText += " STATE_IS_WINDOW";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
			stateText += " STATE_IS_REQUEST";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_START) {
			stateText += " STATE_START";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
			stateText += " STATE_STOP";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_REDIRECTING) {
			stateText += " STATE_REDIRECTING";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_TRANSFERRING) {
			stateText += " STATE_TRANSFERRING";
		}
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_NEGOTIATING) {
			stateText += " STATE_NEGOTIATING";
		}
		writeLog(stateText);
 */		
		if ((aStateFlags & gKESIOnStateFlags) != 0) {		//  6488
			if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_START) {
				writeLog("Send PAGE LOAD START to KESI");
				KESIStartPage();
			} else if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
				writeLog("Send PAGE LOAD STOP to KESI");
				KESIStopPage();		// 6642
			}
		}
/* 		else {
			if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_START) {
			}
			else if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
				// this is a STATE_STOP when STATE_IS_REQUEST is set (not (STATE_IS_DOCUMENT | STATE_IS_NETWORK | STATE_IS_WINDOW), which is 0xE0000)
				// so far, STATE_IS_REQUEST is seen when this happens (no 0 upper 16 bits seen yet...)
				// page changing without a STATE_START (or at least without a document-level STATE_STOP)
				if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
					writeLog("Fake PAGE LOAD START and STOP to KESI");
					// seen in pages that are generated using angular.js (FB 24954)
					KESIStartPage();
					KESIStopPage();
				}
			}
		}
 */
	},

	onLocationChange : function(aWebProgress, aRequest, aLocation, aFlag)
	{
		//writeLog('onLocationChange: ' + aWebProgress.toString() + " " + aFlag.toString());
		KESIHighlightReset();
		KESIClearAllHighlights();
		//KESISendSocketMessage("dLocationChange " + aRequest + " " + aLocation + ";");
		KESISendSocketMessage("b");	// tab changed
		KESISendSelection("c");		// 6642
	},

	onProgressChange: function() {},	// 6560
	onStatusChange: function() {},
	onSecurityChange: function() {},
	onLinkIconAvailable: function() {},

	QueryInterface : function(aIID)
	{
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
				aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
				aIID.equals(Components.interfaces.nsISupports)) {
			return this;
		}
		throw Components.results.NS_NOINTERFACE;
	}
};


// called for mouse clicks
// (event.button = 1 is left, 2 is right)

function KESIBrowserMouseUpHandler(aEvent)
{
	try {
		if (gKESIOutStream) {
			//Firefox 1.4.1 no longer gets "scrollbar" here, but rather "HTML"
			//KESISendSocketMessage("d" + aEvent.target.localName + ";");
			if (aEvent && aEvent.target && (aEvent.target.localName == "scrollbar" || aEvent.target.localName == "HTML"))
			{
				KESISendSocketMessage("s");
			} else {
				saveClickLocation(aEvent);
				KESISendSelection("c");
			}
		}
	} catch (ex) {
		KESIAlert ("KESIBrowserMouseUpHandler: " + ex);
	}
}

function KESIBrowserMouseDownHandler(aEvent)
{
	if (gKESIOutStream)
		KESISendSocketMessage("C");
}

function KESISendSelection(aCmdChar)
{
	try {
		var selection = KESIFocusedSelection();
		var haveValidSelection = selection && !selection.isCollapsed && selection.getRangeAt(0);
		if (!haveValidSelection && clickLocationIsValid(lastClickLocation)) {
			selection = lastClickLocation;
		}

		var selStartLen = KESISelectionOffset(content.document, selection);
		KESISendSocketMessage(aCmdChar + selStartLen[0] + "," + selStartLen[1] + ";");
	} catch (ex) {
		KESIAlert ("KESISendSelection: " + ex);
	}
}

function clickLocationIsValid(clickLocation) {
	// If the window died after the last click, accessing the click location will through, so validate that we still
	// have a valid clicklocation
	return clickLocation && clickLocation.isStillValid();
}

function KESIMakePrintable(aStr)	// for debugging
{
	try {
		var res = "";

		for (var n = 0; n < aStr.length; ++n)
		{
			if (aStr.charCodeAt(n) < 32)
				res = res + "&" + aStr.charCodeAt(n);

			res = res + aStr.charAt(n);
		}

		return res;
	} catch (ex) {
		return "<not a string>";
	}
}

function KESIAlert(aMsg)
{
	if (!gKESISuppressDebuggingAlerts)
	{
		alert("KESIReader error at " + aMsg);
		dump("KESIReader error at " + aMsg);
	}
}

function KESIToUTF8(aStr)
{
	try {
		var outstr = "";
		var cc;
		var c;

		for (var n = 0; n < aStr.length; ++n)
		{
			cc = aStr.charCodeAt(n);

			if (cc <= 127)
			{
				c = aStr.charAt(n);
			}
			else if (cc == 160)	// 6321
			{
				c = " ";
			}
			else if (cc <= 2047)
			{
				c = String.fromCharCode(192 + (cc>>6), 128 + (cc&63));
			}
			else
			{
				c = String.fromCharCode(224 + (cc>>12), 128 + ((cc>>6)&63), 128 + (cc&63));
			}

			outstr += c;
		}
	} catch (ex) {
		KESIAlert ("KESIToUTF8: " + ex);
	}

	return outstr;
}

function KESIComputeOLVals(aNode)
{
	try {
		var children = aNode.childNodes;

		if (aNode.nodeName.toUpperCase() == "OL") {
			KESIComputeLIVals(aNode);
		}

		for(var i = 0; i < children.length; i++) {
			KESIComputeOLVals(children.item(i));
		}
	} catch (ex) {
	}
}

function KESIComputeLIVals(aOlNode)
{
	var value;
	var newvalue;
	var children;
	var current;
	var type;
	var oltype = aOlNode.getAttribute("type");

	if (value = aOlNode.getAttribute("start")) {
		value = parseInt(value);
	} else {
		value = 1;
	}

	children = aOlNode.childNodes;

	for (var i = 0; i < children.length; i++) {
		current = children.item(i);

		if (current.nodeName.toUpperCase() == "LI") {
			if (newvalue = current.getAttribute("value")) 
				value = parseInt(newvalue);
			if (!(type = current.getAttribute("type"))) 
				type = oltype;
			if (type == "a" || type == "A") {
				if (value > 26) {
					// 45 is dash for pronunciation
					current.setAttribute("kesi_val", " " + String.fromCharCode((value / 26) + 64, 45, (value % 26) + 64) + ". ");
				} else {
					current.setAttribute("kesi_val", " " + String.fromCharCode(value + 64) + ". ");
				}
			} else {
				current.setAttribute("kesi_val", " " + value.toString() + ". ");
			}
			++value;
		}
	}
}

function onWindowMessage(event) {
	if (content.window === event.source) {
		if (event.data.type === 'KURZWEIL_WEB_CONTENT_CHANGED') {
			// So this message was originally for actually tab changed, but effectively it means re-ask us what the
			// content of the page is, and be prepared to read the new content
			KESISendSocketMessage('b');
		}
	}
}

// "document" is an HTMLDocument object

function saveClickLocation(event) {
	var caretPosition = content.document.caretPositionFromPoint(event.pageX, event.pageY);
	if (caretPosition) {
		lastClickLocation = {
			rangeCount: 1,
			getRangeAt: function(i) {
				if (i !== 0) {
					throw Error(i + ' is out of bounds');
				}

				return {
					startContainer: caretPosition.offsetNode,
					endContainer: caretPosition.offsetNode,
					startOffset: caretPosition.offset,
					endOffset: caretPosition.offset
				};
			},
			isStillValid: function() {
				return !Components.utils.isDeadWrapper(caretPosition);
			}
		};
	}
}

function KESIGatherText(aDocument)
{
	KESIComputeOLVals(aDocument.firstChild);

	// In websites with dynamic content, we don't know stuff has changed until they tell us. Certain pages,
	// for example Accuplacer, will signal to us when they would like to re-parse the page because they have
	// dynamically modified the page. We listen for that message and reload the content
	// Remove the current listener in case we've been called twice on the same window
	content.window.removeEventListener("message", onWindowMessage);
	content.window.addEventListener("message", onWindowMessage);

	var text = "";

	if (!aDocument)
		return text;

	var nName;
	var altText;

	try
	{
		var node = aDocument.firstChild;

		while(node)
		{
			nName = node.nodeName.toUpperCase();

			// See if this node is text.
			if (nName == "#TEXT")
			{
				// replace newlines with spaces
				text += node.data.replace( /\n|\r/g, " " );
			}
			else if (node.nodeType == 1 && nName == "IMG")
			{
				if (gKESIReadAltText)
				{
					altText = node.getAttribute("alt");

					if (altText && altText != "")
					{
						text += "\r\n" + altText.replace( /\n|\r/g, " " ) + "\r\n";
					}
				}
			}
			else if (node.nodeType == 1 && nName == "INPUT")
			{
				if (gKESIReadAltText)
				{
					altText = KESIGetInputNodeStr(node);

					if (altText != "" )
					{
						text += "\r\n" + altText + "\r\n";
					}
				}
			}
			else if (node.nodeType == 1 && nName == "TEXTAREA")
			{
				//if (gKESIReadAltText)
				//{
					altText = KESIGetTextAreaNodeStr(node);

					if (altText != "" )
					{
						text += "\r\n" + altText + "\r\n";
					}
				//}
			}
			else if (!KESIIsInline(nName))
			{
				if (nName == "LI") {
					try {
						altText = node.getAttribute("kesi_val");
						if (altText) text += altText;
					} catch (ex) {}
				}

				text += "\r\n";
			}

			// Find next node to test.
			// First, see if this node has children.
			if (node.hasChildNodes() &&
			nName != "HEAD" && 	// nothing interesting in HEAD
			nName != "SCRIPT" && nName != "NOSCRIPT" &&
			nName != "INPUT" && nName != "TEXTAREA" && nName != "STYLE" && nName != "NOFRAMES" &&
			nName != "FRAME" && nName != "IFRAME" && nName != "SELECT" &&
			!KESIIsNodeHidden(node)) //#3820
			{
			 // Go to first child.
				node = node.firstChild;    
			}
			else
			{
				if (nName == "FRAME" || nName == "IFRAME")
				{
					//Frames do not have children (except script) and the child document
					//  does not have a parent: need to recurse
					text += "\r\n" + KESIGatherText(node.contentDocument);
				}

				// No children, try next sibling.
				// Or KESIIsNodeHidden
				if (node.nextSibling)
				{
					node = node.nextSibling;
				}
				else
				{
					// Loop upward until a sibling is found!
					var addCRLF = false;

					while ((node = node.parentNode))
					{
						// Catch case like:  para text <H1>Header</H1> second para
						if (!KESIIsInline(node.nodeName.toUpperCase()))
						{
							addCRLF = true;
						}

						if (node.nextSibling)
						{
							node = node.nextSibling;
							break;
						}
					}

					if (addCRLF)
					{
						text += "\r\n";
					}
				}
			}
		}
	} catch (ex) {
		KESIAlert("KESIGatherText: " + ex + " Node: " + node + " Name: " + nName);
	}
	return text;
}

// #3820
function KESIIsNodeHidden(aNode)
{
 	
	if (aNode.style){
		if (aNode.style.visibility=="hidden" || aNode.style.display=="none"){
			return true;
		}
	}
	
	if (window.getComputedStyle) {
		var style = window.getComputedStyle(aNode, "");
		if (style.display == 'none') return true;
		if (style.visibility == 'hidden') return true;
	}
	
	return false;

}

function KESIGetInputNodeStr(aNode)
{
	var altText = "";
	var nType;

	try {
		nType = aNode.getAttribute("type")
		if (nType == "submit" || nType == "text")
			altText = aNode.getAttribute("value");

		if (!altText || altText == "")
			altText = aNode.getAttribute("alt");

		if (!altText)
			altText = "";
	} catch (ex) {
		KESIAlert("KESIGetInputNodeStr: " + ex);
	}

	return altText.replace( /\n|\r/g, " " );  // replace newlines with spaces
}


function KESIGetTextAreaNodeStr(aNode)
{
	var altText = "";

	try {
		altText = aNode.value;

		if (!altText)
			altText = "";
	} catch (ex) {
		KESIAlert("KESIGetTextAreaNodeStr: " + ex);
	}
	return altText.replace( /\n|\r/g, " " );  // replace newlines with spaces
}


function KESIIsInline(aNodeName)
{
	switch (aNodeName)
	{
		case "A":
		case "ADDRESS":
		case "BIG":
		case "BLINK":
		case "B":
		case "CITE":
		case "CODE":
		case "DFN":
		case "EM":
		case "FONT":
		case "I":
		case "KBD":
		case "KEYGEN":
		case "NOBR":
		case "S":
		case "SAMP":
		case "SMALL":
		case "SPACER":
		case "SPAN":
		case "STRIKE":
		case "STRONG":
		case "SUB":
		case "SUP":
		case "TT":
		case "U":
		case "VAR":
		case "WBR":
		case "#TEXT":
		case "#COMMENT":
		case "FRAME":	// treat these like inline
		case "FRAMESET":
		case "IFRAME":
		case "#DOCUMENT":
		return true;

		default:
		return false;
	}
}

// Remember a starting point to speed up successive highlighting calls
var gKESILastHLPos = -1;
var gKESILastHLNode = null;
var gKESILastHLDocument;
var gKESILastHLParentDocument;
var gKESILastHLDepth;
var gKESIFrameStack = new Array(1);
var gKESIFrameDepth = 0;

// Reset the memory of the optimization starting point

function KESIHighlightReset()
{
	gKESILastHLPos = -1;
	gKESILastHLNode = null;
	gKESILastHLDocument = null;
	gKESILastHLParentDocument = null;
	gKESIFrameDepth = 0;
	gKESIFrameStack.length = 0;
}


// selStart is 0-based
// "document" is an HTMLDocument object
// If the selection (or groups) spans several frames, only the last piece will survive
// If selLength = 0, position the caret (and scroll the parent if group B)

function KESIHighlightText(aParentDocument, aSelStart, aSelLength, aSelColor, aSelGroup)
{
	var pos;
	var len;
	var node;
	var nextSib;
	var nName;
	var depth;
	var baseID = "KESIHighlight" + aSelGroup;
	var id = 0;
	var spanNode = null;
	var skipChildren = false;
	var groupA = (aSelGroup == "A");	// group A is single word
	var selLengthRem = aSelLength;
	var document;
	var altText;
	var altLen;

	try
	{
		if (gKESILastHLPos < 0 || aSelStart < gKESILastHLPos || aParentDocument != gKESILastHLParentDocument)
		{
			// start at beginning
			document = aParentDocument;
			pos = 0;
			node = document.firstChild;
			depth = 1;
			gKESIFrameDepth = 0;
			gKESIFrameStack.length = 0;
		}
		else
		{
			// start where we left off
			document = gKESILastHLDocument;
			pos = gKESILastHLPos;
			node = gKESILastHLNode;
			depth = gKESILastHLDepth;
		}

		gKESILastHLParentDocument = aParentDocument;

		while (node && depth > 0)
		{
			nName = node.nodeName.toUpperCase();
			nextSib = node.nextSibling;

			if (nName == "#TEXT")
			{
				len = node.data.length;
				if (pos + len > aSelStart)
				{
					var colorNode;
					if (document != gKESIHighlightDoc)
					{
						KESIClearAllHighlights();
						gKESIHighlightDoc = document;
						id = 0;
					}

					if (aSelLength == 0)
					{
						break;
					}

					if (pos >= aSelStart)
					{
						if (pos + len <= aSelStart + selLengthRem)
						{
							// selection includes entire node
							colorNode = node;
							selLengthRem = aSelStart + selLengthRem - (pos + len);
							aSelStart = pos + len;
						}
						else
						{
							// selection is front of node
							var nl = aSelStart + selLengthRem - pos;

							if (nl <= 0)
							{
								break;		// could be alt text before the node
							}

							node.splitText(nl);
							colorNode = node;
							nextSib = null;
							depth = -10000;	// force a break
						}
					}
					else
					{
						if (pos + len > aSelStart + selLengthRem)
						{
							// selection is middle chunk of node
							colorNode = node.splitText(aSelStart - pos);
							node = colorNode.splitText(selLengthRem);
							nextSib = null;
							depth = -10000;	// force a break
						}
						else
						{
							// selection is tail of node
							colorNode = node.splitText(aSelStart - pos);
							node = colorNode;
							selLengthRem -= len - (aSelStart - pos);
							aSelStart = pos + len;
						}
					}
					var colorClone = colorNode.cloneNode(true);
					spanNode = document.createElement("span");
					++id;
					spanNode.setAttribute("id", baseID + id);
					spanNode.style.backgroundColor = aSelColor;
					spanNode.style.display = "inline";	// 6712
					spanNode.appendChild(colorClone);
					colorNode.parentNode.replaceChild(spanNode, colorNode);

					if (selLengthRem <= 0)
					{
						depth = -10000;
					}

					node = spanNode;
					skipChildren = true;	// don't look at stuff we just added!
				}

				pos += len;

				if (depth < 0)
				{
					break;
				}
			}
			else if (node.nodeType == 1 && nName == "IMG")
			{
				if (gKESIReadAltText)
				{
					altText = node.getAttribute("alt");

					if (altText)
					{
						altLen = altText.length;

						if (altLen > 0)
						{
							pos += altLen + 4;
						}
					}
				}
			}
			else if (node.nodeType == 1 && nName == "INPUT")
			{
				if (gKESIReadAltText)
				{
					altText = KESIGetInputNodeStr(node);
					altLen = altText.length;

					if (altLen > 0)
					{
						pos += altLen + 4;
					}
				}
			}
			else if (node.nodeType == 1 && nName == "TEXTAREA")
			{
				altText = KESIGetTextAreaNodeStr(node);
				altLen = altText.length;

				if (altLen > 0)
				{
					pos += altLen + 4;
				}
			}
			else if (!KESIIsInline(nName))
			{
				// Save a possible place to start again next time
				//   (Note that this incidentally avoids the temporary spans we are adding)

				gKESILastHLPos = pos;
				gKESILastHLNode = node;
				gKESILastHLDocument = document;
				gKESILastHLDepth = depth;

				if (nName == "LI") {
					try {
						altText = node.getAttribute("kesi_val");
						if (altText) pos += altText.length;
					} catch (ex) {}
				}

				pos += 2;
			}

			if (node.hasChildNodes() && !skipChildren &&
			nName != "HEAD"     &&  nName != "SCRIPT" &&
			nName != "NOSCRIPT" &&  nName != "INPUT"  && nName != "TEXTAREA" &&
			nName != "STYLE" && nName != "FRAME" && nName != "NOFRAMES" &&
			nName != "IFRAME" && nName != "SELECT" &&
			!KESIIsNodeHidden(node)) // #3820
			{
				depth++;
				node = node.firstChild;
			}
			else
			{
				skipChildren = false;

				if (nName == "FRAME" || nName == "IFRAME")
				{
					pos += 2;
					depth++;
					gKESIFrameStack[gKESIFrameDepth++] = node;
					document = node.contentDocument;
					node = document.firstChild;
				}
				else if (nextSib)
				{
					node = nextSib;
				}
				else
				{
					var addCRLF = false;

					while (depth > 0)
					{
						node = node.parentNode;
						if (node) {
							--depth;
						} else {	// 6487
							if (gKESIFrameDepth <= 0)
							{
								break;		// 6298 #document has null parentNode
							}

							node = gKESIFrameStack[--gKESIFrameDepth];
							gKESIFrameStack[gKESIFrameDepth] = null;

							if (!node)
							{
								break;
							}

							if (addCRLF)	//6349
							{
								addCRLF = false;
								pos += 2;
							}

							document = node.ownerDocument;
							gKESILastHLPos = -1;			// 6298
						}

						if (!KESIIsInline(node.nodeName.toUpperCase()))
						{
							addCRLF = true;
						}

						if (node.nextSibling)
						{
							node = node.nextSibling;
							break;
						}
					}

					if (addCRLF)
					{
						pos += 2;
					}
				}
			}
		}

		if (aSelLength == 0 && !spanNode && node)
		{
			//set caret
			var selection = KESIFocusedSelection();
			if (selection) selection.removeAllRanges();
			var range = aParentDocument.createRange();
			var offset = aSelStart - pos;

			if (offset < 0) {
				offset = 0;
			}

			try {
				// this can fail for degenerate documents
				range.setStart(node, offset);
				range.setEnd(node, offset);
				selection.addRange(range);
				KESISetSelectionVisibility(true);
				spanNode = node;
			} catch (ex) {
			}
		}
	} catch (ex) {
		KESIAlert("KESIHighlightText: " + ex);
		//KESIAlert("aSelStart: " + aSelStart + " aSelLength: " + aSelLength);
		//KESIAlert("pos: " + pos + " len: " + len + " data: " + KESIMakePrintable(node.data));
	}
	return pos;
}

function KESISetSelectionVisibility(aCaretVisible)
{
	try {
		var selCon = gKESIBrowser.docShell.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
				.getInterface(Components.interfaces.nsISelectionDisplay)
				.QueryInterface(Components.interfaces.nsISelectionController);

		if (aCaretVisible)
		{
			selCon.setCaretEnabled(aCaretVisible);
			selCon.setDisplaySelection(Components.interfaces.nsISelectionController.SELECTION_ON);
			//selCon.setCaretVisibilityDuringSelection(false);
		}
		else
		{
			selCon.setCaretEnabled(aCaretVisible);
			selCon.setDisplaySelection(Components.interfaces.nsISelectionController.SELECTION_HIDDEN);
			//selCon.setCaretVisibilityDuringSelection(false);
		}
	} catch(ex) {
		KESIAlert("KESISetSelectionVisibility: " + ex);
	}
}


// Get selection object of the frame that is in focus.
// See http://developer-test.mozilla.org/docs/Safely_accessing_content_DOM_from_chrome\

function KESIFocusedSelection()
{
	try {
		var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, "document", "getSelection()");

		if (focusedWindow)
		{
			var selection = focusedWindow.getSelection();

			if (selection)
				return selection;
		}
	} catch (ex) {
		KESIAlert("KESIFocusedSelection: " + ex);
	}
	return null;
}


// return [offset, length] of a Mozilla selection
// offset is zero based. length is -1 if there is no selection.
// document is an HTMLDocument object

function KESISelectionOffset(aDocument, aSelection)
{
	var node;
	var pos = 0;
	var len;
	var nextSib;
	var nName;
	var depth = 1;
	var selStart = -1;
	var selEnd = -1;
	var selRange;
	var addCRLF = false;
	var altText;

	try {
		if(!aSelection || aSelection.rangeCount <= 0 || !(selRange = aSelection.getRangeAt(0)))
		{
			return [-1, -1];
		}

		node = aDocument.firstChild;

		while (node && depth > 0)
		{
			if (node == selRange.startContainer)
			{
				selStart = pos + selRange.startOffset;
			}

			if (node == selRange.endContainer)
			{
				selEnd = pos + selRange.endOffset;
			}

			if (selStart >= 0 && selEnd >= 0)
			{
				break;
			}

			nName = node.nodeName.toUpperCase();
			nextSib = node.nextSibling;

			if (nName == "#TEXT")
			{
				len = node.data.length;
				pos += len;
			}
			else if (node.nodeType == 1 && nName == "IMG")
			{
				altText = node.getAttribute("alt");

				if (altText && altText != "" && gKESIReadAltText)
				{
					pos += altText.length + 4;
				}
			}
			else if (node.nodeType == 1 && nName == "INPUT")
			{
				altText = KESIGetInputNodeStr(node);

				if (altText != "" && gKESIReadAltText)
				{
					pos += altText.length + 4;
				}
			}
			else if (node.nodeType == 1 && nName == "TEXTAREA")
			{
				altText = KESIGetTextAreaNodeStr(node);

				if (altText != "" ) // && gKESIReadAltText)
				{
					pos += altText.length + 4;
				}
			}
			else if (!KESIIsInline(nName))
			{
				if (nName == "LI") {
					try {
						altText = node.getAttribute("kesi_val");
						if (altText) pos += altText.length;
					} catch (ex) {}
				}

				pos += 2;
			}

			if (node.hasChildNodes() && nName != "HEAD" && nName != "SCRIPT" &&
				nName != "NOSCRIPT" && nName != "INPUT" && nName != "TEXTAREA" && nName != "STYLE" &&
				nName != "FRAME" && nName != "NOFRAMES" && nName != "IFRAME" && nName != "SELECT" &&
				!KESIIsNodeHidden(node)) // #3820
			{
				depth++;
				node = node.firstChild;
			}
			else
			{
				if (nName == "FRAME" || nName == "IFRAME")
				{
					pos += 2;
					var framePos = KESISelectionOffset(node.contentDocument, aSelection);

					if (framePos[0] >= 0)
					{
						return [pos + framePos[0], framePos[1]];
					}

					pos -= framePos[0] + 1;
				}

				if (nextSib)
				{
					node = nextSib;
				} else {
					addCRLF = false;

					while ((node = node.parentNode) && depth-- > 0)
					{
						if (!KESIIsInline(node.nodeName.toUpperCase()))
						{
							addCRLF = true;
						}

						if (node.nextSibling)
						{
							node = node.nextSibling;
							break;
						}
					}

					if (addCRLF)
					{
						pos += 2;
					}
				}
			}
		}
	} catch (ex) {
		KESIAlert("KESISelectionOffset: " + ex);
	}

	if (selStart >= 0) {
		if (selEnd < 0) {
			selEnd = selStart;	// should not happen
		}

		if (selEnd >= selStart) {
			return [selStart, selEnd - selStart];
		} else {
			return [selEnd, selStart - selEnd];
		}
	}

	return [-pos - 1, 0];	// selection not found (in this frame) (-1 adjusts for zero case)
}


function KESIClearAllHighlights()
{
	if (gKESIHighlightDoc)
	{
		while (KESIClearHighlightGroup(gKESIHighlightDoc, "A") > 1);
		while (KESIClearHighlightGroup(gKESIHighlightDoc, "B") > 1);
		gKESIHighlightDoc = null;
	}
}

// Note that highlight ID numbers must always be used in continuous runs,
// since this stops once an ID number is not found. Returns number of first ID not found.

function KESIClearHighlightGroup(aDocument, aSelGroup)
{
	var id = 1;

	try {
		if (!aDocument)
			return id;

		var baseID = "KESIHighlight" + aSelGroup;

		for (; true; ++id)
		{
			var oldSpan = aDocument.getElementById(baseID + id);

			if (!oldSpan)
				break;

			var parent = oldSpan.parentNode;
			if (!parent) break;
			parent.replaceChild(oldSpan.childNodes[0], oldSpan);
			parent.normalize();
		}
	} catch (ex) {
		KESIAlert("KESIClearHighlightGroup: " + ex);
	}

	return id;
}


function KESIInit2()
{
	if (gKESIInit2Done) return;
	gKESIInit2Done = true;

	try {
		window.addEventListener("focus", KESIWinFocusListener, false);
		KESIHighlightReset();
	} catch (ex) {
		KESIAlert("KESIInit2: " + ex);
	}
}

function KESIInit3()
{
	try {
		//gKESIBrowser = top.document.getElementById("content");
		gKESIBrowser = document.getElementById("content");		// actually tabbrowser
		gKESIBrowser.addEventListener("mouseup", KESIBrowserMouseUpHandler, false);

		// see currently https://developer.mozilla.org/en-US/docs/Mozilla/Tech/XPCOM/Reference/Interface/nsIWebProgress
		// for a description of the constants passed in the second parameter
		gKESIBrowser.addProgressListener(KESIBrowserProgressListener,
					Components.interfaces.nsIWebProgress.NOTIFY_STATE_ALL |
					Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);

		if (gKESIIsMac)
			gKESIBrowser.addEventListener("mousedown", KESIBrowserMouseDownHandler, false);
	} catch (ex) {
		KESIAlert("KESIInit3: " + ex);
	}
}

function KESIWinFocusListener()
{
	if (gKESIOutStream)
		KESISendSocketMessage("f");
}


// gets called twice per window load

function KESIWindowLoadHandler(aEvent)
{
	if (++gKESILoadWinCounter == 1) return;	//6560

	KESIConnect();
}

function KESIConnect()
{
	KESIInitSocket();
	if (!KESISendSocketMessage("w")) 
		return;
	if (KESISendSocketMessage("a")) {
		KESIInit3();
	}
}

function KESIWinUnloadHandler()
{
	try {
		KESISendSocketMessage("u");
		KESIHighlightReset();
		KESIClearAllHighlights();
		KESICloseConnection();

		if (gKESIBrowser) {
			gKESIBrowser.removeProgressListener(KESIBrowserProgressListener);
		}

		gKESIBrowser = null;
		gKESIInit2Done = false;
	} catch (ex) { }
}

function KESICloseConnection()
{
	try {
		if (gKESIInStream) {
			gKESIInStream.close();
			gKESIInStream = null;
		}
	} catch (ex) {
		KESIAlert("KESICloseConnection In: " + ex);
	}

	try {
		if (gKESIOutStream)	{
			gKESIOutStream.close();
			gKESIOutStream = null;
		}
	} catch (ex) {
		KESIAlert("KESICloseConnection Out: " + ex);
	}
}

function KESIGetPrefs()
{
	try {
		var prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var Branch = prefObj.getBranch("kesireader.");

		if (Branch.prefHasUserValue("port")) {
			gKESIPort = Branch.getIntPref("port");
		} else {
			if (gKESIIsMac) gKESIPort = 5002;
			Branch.setIntPref("port", gKESIPort);
		}

		if (Branch.prefHasUserValue("startPort")) {
			gKESIStartupPort = Branch.getIntPref("startPort");
		} else {
			Branch.setIntPref("startPort", gKESIStartupPort);
		}

		if (Branch.prefHasUserValue("suppressDebuggingAlerts")) {
			gKESISuppressDebuggingAlerts = Branch.getBoolPref("suppressDebuggingAlerts");
		} else {
			Branch.setBoolPref("suppressDebuggingAlerts", gKESISuppressDebuggingAlerts);
		}

		if (Branch.prefHasUserValue("exePath")) {
			gKESIExePath = Branch.getCharPref("exePath");
		} else {
			Branch.setCharPref("exePath", gKESIExePath);
		}
	} catch(ex) {
		KESIAlert("KESIGetPrefs: " + ex);
	}
}

//Called externally
function KESI_Prev()
{
	KESI_Command("prev");
}

//Called externally
function KESI_Play()
{
	var playButton = document.getElementById("KESI-Play");

	if (playButton.checked == true) {
		KESISendMsgOrLaunch("mmnuPauseReading;");
	} else {
		if (gKESIOutStream) {
			KESIDoCommand("r");
		} else {
			KESISendMsgOrLaunch("mmnuReadStartReading;");
		}
	}
}

//Called externally
function KESI_Next()
{
	KESI_Command("next");
}

//Called externally
function KESI_Dict()
{
	KESI_Command("dict");
}

//Called externally
function KESI_Syl()
{
	KESI_Command("syl");
}

//Called externally
function KESI_Mag()
{
	KESI_Command("mag");
}

//Called externally
function KESI_Command(aArg)
{
	switch(aArg)
	{
		case "prev":
		KESISendMsgOrLaunch("mmnuReadBack;");
		break;

		case "next":
		KESISendMsgOrLaunch("mmnuReadForward;");
		break;

		case "dict":
		KESISendMsgOrLaunch("mmnuGetDefinition;");
		break;

		case "syl":
		KESISendMsgOrLaunch("mmnuGetSyllables;");
		break;

		case "mag":
		KESISendMsgOrLaunch("mmnuViewMagnifySpokenWord;");
		break;

		default:
		break;
	}
}

function KESISendMsgOrLaunch(aMsg)
{
	var localizedStrings = document.getElementById("string-bundle");
	var alertString = localizedStrings.getString('alertString');
	var confirmString = localizedStrings.getString('confirmString');
	
  // #8909 process might be killed, reset the status
	if(gKESIProcessInitDone){
		if(!gKESIProcess.isRunning){
		 		gKESI3000LaunchStatus=0;
		}
	}
  			
	if (gKESIOutStream || gKESI3000LaunchStatus > 1) {
		KESISendSocketMessage(aMsg);
		return;
	} 
	
	if (gKESI3000LaunchStatus == 1) {
		alert(alertString);
		return;	
	}
	
	// if we are here, gKESI3000LaunchStatus must be 0
	if (confirm(confirmString)) {
		KESI_Launch();
	}
}

// Logo button calls this externally
function KESI_Launch()
{
	var localizedStrings = document.getElementById("string-bundle");
	var notFoundString = localizedStrings.getString('notFoundString') + " ";
	var launchingString = localizedStrings.getString('launchingString');
	var pleaseWaitString = localizedStrings.getString('pleaseWaitString');
	var localizedPathToMacApp = localizedStrings.getString('localizedPathToMacApp');
	
	if (gKESIOutStream || gKESI3000LaunchStatus > 0) return true;

	try {
	
		if(gKESIProcessInitDone){ // #8908
				window.status = launchingString;
				gKESIProcess.run(false, ["-firefox"], 1);		
				return true;
		}
		
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);

		gKESIProcess = Components.classes["@mozilla.org/process/util;1"]
			.getService(Components.interfaces.nsIProcess);	

		file.initWithPath(gKESIExePath);

		if(!file.exists())
		{
            if (gKESIIsMac)
            {
                //gKESIExePath = "/Applications/Kurzweil 3000.app/Contents/MacOS/Kurzweil 3000";
                gKESIExePath = localizedPathToMacApp;
            } else {
                // #5056 ActiveXObject and RegRead only work for IE, so we are
                // not reading from the registry for the path
                gKESIExePath = "C:\\Program Files (x86)\\Kurzweil Educational Systems\\Kurzweil 3000\\Kurzweil 3000.exe";
            }
			
			// was missing from this version of source!  Required to prevent 'failure to find K3000.exe to launch it'
            // message when on a 64 bit windows OS (should affect Mac as well, but maybe not?)
            file.initWithPath(gKESIExePath);
            if(!file.exists())
            {
                alert(notFoundString + " " + gKESIExePath);
                return false;
            }
		}

			 
		KESICloseConnection();
		if (!KESIListenForStart()) return false;

		gKESI3000LaunchStatus = 1;
		gKESIProcess.init(file);
	  gKESIProcessInitDone = true;
	
		window.status = pleaseWaitString;
		gKESIProcess.run(false, ["-firefox"], 1);		
		return true;
	} catch(ex) {
		alert(ex);
		return false;
	}

	return false;
}

function KESIListenForStart()
{
	if (gKESIStartupSocket) return gKESIStartupSocket;

	try {
		gKESIStartupSocket = Components.classes["@mozilla.org/network/server-socket;1"]
			.createInstance(Components.interfaces.nsIServerSocket);

		gKESIStartupSocket.init(gKESIStartupPort, true, -1);
		gKESIStartupSocket.asyncListen(KESIStartupListener);
	} catch(ex) {
		KESIAlert("KESIListenForStart: " + ex);
	}

	return gKESIStartupSocket;
}

var KESIStartupListener =
{
	onSocketAccepted : function(serverSocket, transport) {
		gKESI3000LaunchStatus = 2;
		KESIConnect();
		KESISendSocketMessage("b");
		// close takes a status (nsresult) that seems to be from Components.interfaces.nsITransportEventSink
		transport.close(Components.interfaces.nsITransportEventSink.STATUS_RESOLVED);
	},

	onStopListening : function(serverSocket, status){}
};

//Called externally
function KESI_ReadMode(aArg)
{
	switch(aArg)
	{
		case "continuous":
		KESISendMsgOrLaunch("mmnuReadContinuous;");
		break;

		case "self":
		KESISendMsgOrLaunch("mmnuReadSelfPaced;");
		break;

		case "word":
		KESISendMsgOrLaunch("mmnuReadWordbyWord;");
		break;

		default:
		break;
	}
}

//Called externally
function KESI_WPM(aArg)
{
	KESISendMsgOrLaunch("W" + aArg + ";");
}

//Called externally
function KESI_ReadBy(aArg)
{
	switch(aArg)
	{
		case "word":
		KESISendMsgOrLaunch("mmnuReadByWord;");
		break;

		case "phrase":
		KESISendMsgOrLaunch("mmnuReadByPhrase;");
		break;

		case "line":
		KESISendMsgOrLaunch("mmnuReadByLine;");
		break;

		case "sentence":
		KESISendMsgOrLaunch("mmnuReadBySentence;");
		break;

		case "paragraph":
		KESISendMsgOrLaunch("mmnuReadByParagraph;");
		break;

		case "heading":
		KESISendMsgOrLaunch("mmnuReadByHeading;");
		break;

		default:
		break;
	}
}


function KESIInit1()
{
	try {
		var agent = navigator.userAgent.toLowerCase();
		gKESIIsMac = (agent.indexOf("mac") != -1);
		KESIGetPrefs();

		window.addEventListener("load", KESIWindowLoadHandler, false);
		window.addEventListener("unload", KESIWinUnloadHandler, false);
	} catch(ex) {
		KESIAlert("KESIInit1: " + ex);
	}
}

KESIInit1();	// trigger initializations
